const dbUtil = require('../utils/dbUtil.js');   // 引入dbUtil模块     
const uuid = require('uuid');

// 查询所有日记(按发布时间逆序排列)
async function getAllDiaries() {
    return await dbUtil.query('select d.*, u.nickName as author from diary d inner join user_info u on d.userId = u.id order by d.publishTime desc');
}

// 新增日记
async function addDiary(params) {
    const fields = ['id', 'userId', 'title', 'publishTime', 'cover', 'content', 'audioPath', 'audioDuration'];
    const sqlAndValuesOfNewDiary = dbUtil.buildInsert('diary', fields, params, function (field, defaultValue) {
        switch (field) {
            case 'id': return uuid.v1();    // 使用uuid作为记录主键
            case 'userId': return 'u1';		// 假设日记都是u1用户发表的(以后处理)
            case 'publishTime': return new Date();
            default: return defaultValue;
        }
    });

    // 更新作者日记数的SQL语句
    const sqlUpdateDiaryCnt = 'update user_info set diaryCnt = diaryCnt + 1 where id = ?';
    // 对应的参数, 假设日记是u1用户发表的(以后处理)
    const valuesUpdateDiaryCnt = ['u1'];

    // 执行两条语句
    await dbUtil.query([sqlAndValuesOfNewDiary.sql, sqlUpdateDiaryCnt], [sqlAndValuesOfNewDiary.values, valuesUpdateDiaryCnt]);
}

module.exports = {
    getAllDiaries,
    addDiary
}